#include<Servo.h>
#include<NewPing.h>

#define TrigDistPin A1
#define EchoDistPin A0
#define ledPin 13
#define motorRforward 2
#define motorRbackward 3
#define motorLforward 4
#define motorLbackward 5
#define ServoPin 9

#define MAX_DISTANCE 200
#define DETECT_DISTANCE 25
#define KEEP_DISTANCE 50

NewPing sonar(TrigDistPin, EchoDistPin, MAX_DISTANCE);


Servo myservo;

int pos = 90; // initial pos of servo
int stopPos = 0;
int found = 0;
int left = 1;
int right = 0;

unsigned long seconds = 1000; // = 1 second

void setup() {
  // put your setup code here, to run once:
  pinMode(motorRforward, OUTPUT);
  pinMode(motorRbackward, OUTPUT);
  pinMode(motorLforward, OUTPUT);
  pinMode(motorLbackward, OUTPUT);
  myservo.attach(ServoPin);
  pinMode(ledPin, OUTPUT);
  Serial.begin(9600);
  pinMode(TrigDistPin, OUTPUT);
  digitalWrite(TrigDistPin, 1);
}

void loop() {
  // put your main code here, to run repeatedly:

  unsigned int distance = sonar.ping_cm();

  if (distance == 0) {
    distance = MAX_DISTANCE;
  }

  if (found == 0) {
    digitalWrite(ledPin, LOW);
    Serial.print("distance = ");
    Serial.println(distance);
    if (left == 1 && pos < 150) {
      pos = pos + 1;
      myservo.write(pos);
      delay(15);
      if (distance < DETECT_DISTANCE) {
        found = 1;
        stopPos = pos;
        pos = 90;
        myservo.write(pos);
        Serial.print("stopPos = ");
        Serial.println(stopPos);
      }
    } else if (left == 1 && pos == 150) {
      right = 1;
      left = 0;
    } else if (right == 1 && pos > 30) {
      pos = pos - 1;
      myservo.write(pos);
      delay(15);
      if (distance < DETECT_DISTANCE) {
        found = 1;
        stopPos = pos;
        pos = 90;
        myservo.write(pos);
        Serial.print("stopPos = ");
        Serial.println(stopPos);
      }
    } else if (right == 1 && pos == 30) {
      right = 0;
      left = 1;
    }
  } else {
    digitalWrite(ledPin, HIGH);
    if (stopPos <= 150 && stopPos > 90) {
      unsigned long starttime = millis();
      unsigned long endtime = starttime;
      
      while ((endtime - starttime) <= seconds * (0.5 * (stopPos - pos) / 60)) {
        digitalWrite(motorRforward, HIGH);
        digitalWrite(motorRbackward, LOW);

        digitalWrite(motorLforward, LOW);
        digitalWrite(motorLbackward, LOW);

        endtime = millis();
      }
      
      stopPos = 0;

      if (distance < 80) {
        Serial.print("Distanta acum: ");
        Serial.println(distance);
        digitalWrite(motorLforward, LOW);
        digitalWrite(motorLbackward, LOW);

        digitalWrite(motorRforward, LOW);
        digitalWrite(motorRbackward, LOW);
      } else {
        Serial.print("Distanta acum: ");
        Serial.println(distance);
        digitalWrite(motorLforward, HIGH);
        digitalWrite(motorLbackward, LOW);

        digitalWrite(motorRforward, HIGH);
        digitalWrite(motorRbackward, LOW);
      }
      
    } else if (stopPos >= 30 && stopPos < 90) {
      unsigned long starttime = millis();
      unsigned long endtime = starttime;

      while ((endtime - starttime) <= seconds * (0.5 * (pos - stopPos) / 60)) {
        digitalWrite(motorLforward, HIGH);
        digitalWrite(motorLbackward, LOW);

        digitalWrite(motorRforward, LOW);
        digitalWrite(motorRbackward, LOW);

        endtime = millis();
      }

      stopPos = 0;
      
    }

    if (distance < KEEP_DISTANCE) {
        Serial.print("Distanta acum: ");
        Serial.println(distance);
        digitalWrite(motorLforward, LOW);
        digitalWrite(motorLbackward, LOW);

        digitalWrite(motorRforward, LOW);
        digitalWrite(motorRbackward, LOW);
      } else {
        Serial.print("Distanta acum: ");
        Serial.println(distance);
        digitalWrite(motorLforward, HIGH);
        digitalWrite(motorLbackward, LOW);

        digitalWrite(motorRforward, HIGH);
        digitalWrite(motorRbackward, LOW);
      }
  }

}
